/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// line - A number to reference the line of the script.    command - One of the ScriptCommandType commands.    parameters - The parameter block corresponding to the the command.    expression - expression to evaluate to determine next step.    whenTrue - Line number to go to in the script when expression returns true.    whenFalse - Line number to go to in the script when expression returns false.
    /// </summary>
    [DataContract]
        public partial class ScriptCommand :  IEquatable<ScriptCommand>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ScriptCommand" /> class.
        /// </summary>
        /// <param name="line">line.</param>
        /// <param name="command">command.</param>
        /// <param name="parameters">parameters.</param>
        /// <param name="expression">expression.</param>
        /// <param name="whenTrue">whenTrue.</param>
        /// <param name="whenFalse">whenFalse.</param>
        public ScriptCommand(int? line = default(int?), ScriptCommandType command = default(ScriptCommandType), object parameters = default(object), string expression = default(string), int? whenTrue = default(int?), int? whenFalse = default(int?))
        {
            this.Line = line;
            this.Command = command;
            this.Parameters = parameters;
            this.Expression = expression;
            this.WhenTrue = whenTrue;
            this.WhenFalse = whenFalse;
        }
        
        /// <summary>
        /// Gets or Sets Line
        /// </summary>
        [DataMember(Name="line", EmitDefaultValue=false)]
        public int? Line { get; set; }

        /// <summary>
        /// Gets or Sets Command
        /// </summary>
        [DataMember(Name="command", EmitDefaultValue=false)]
        public ScriptCommandType Command { get; set; }

        /// <summary>
        /// Gets or Sets Parameters
        /// </summary>
        [DataMember(Name="parameters", EmitDefaultValue=false)]
        public object Parameters { get; set; }

        /// <summary>
        /// Gets or Sets Expression
        /// </summary>
        [DataMember(Name="expression", EmitDefaultValue=false)]
        public string Expression { get; set; }

        /// <summary>
        /// Gets or Sets WhenTrue
        /// </summary>
        [DataMember(Name="whenTrue", EmitDefaultValue=false)]
        public int? WhenTrue { get; set; }

        /// <summary>
        /// Gets or Sets WhenFalse
        /// </summary>
        [DataMember(Name="whenFalse", EmitDefaultValue=false)]
        public int? WhenFalse { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ScriptCommand {\n");
            sb.Append("  Line: ").Append(Line).Append("\n");
            sb.Append("  Command: ").Append(Command).Append("\n");
            sb.Append("  Parameters: ").Append(Parameters).Append("\n");
            sb.Append("  Expression: ").Append(Expression).Append("\n");
            sb.Append("  WhenTrue: ").Append(WhenTrue).Append("\n");
            sb.Append("  WhenFalse: ").Append(WhenFalse).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ScriptCommand);
        }

        /// <summary>
        /// Returns true if ScriptCommand instances are equal
        /// </summary>
        /// <param name="input">Instance of ScriptCommand to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ScriptCommand input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Line == input.Line ||
                    (this.Line != null &&
                    this.Line.Equals(input.Line))
                ) && 
                (
                    this.Command == input.Command ||
                    (this.Command != null &&
                    this.Command.Equals(input.Command))
                ) && 
                (
                    this.Parameters == input.Parameters ||
                    (this.Parameters != null &&
                    this.Parameters.Equals(input.Parameters))
                ) && 
                (
                    this.Expression == input.Expression ||
                    (this.Expression != null &&
                    this.Expression.Equals(input.Expression))
                ) && 
                (
                    this.WhenTrue == input.WhenTrue ||
                    (this.WhenTrue != null &&
                    this.WhenTrue.Equals(input.WhenTrue))
                ) && 
                (
                    this.WhenFalse == input.WhenFalse ||
                    (this.WhenFalse != null &&
                    this.WhenFalse.Equals(input.WhenFalse))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Line != null)
                    hashCode = hashCode * 59 + this.Line.GetHashCode();
                if (this.Command != null)
                    hashCode = hashCode * 59 + this.Command.GetHashCode();
                if (this.Parameters != null)
                    hashCode = hashCode * 59 + this.Parameters.GetHashCode();
                if (this.Expression != null)
                    hashCode = hashCode * 59 + this.Expression.GetHashCode();
                if (this.WhenTrue != null)
                    hashCode = hashCode * 59 + this.WhenTrue.GetHashCode();
                if (this.WhenFalse != null)
                    hashCode = hashCode * 59 + this.WhenFalse.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
